﻿#Implement Software-Defined Storage
#Manually configure cache mode settings
Enable-ClusterS2D -CacheDeviceModel “CONTOSO NVME-1520”
Set-ClusterS2D -CacheModeSSD ReadWrite

#Deploy iSCSI Server on Windows Server 2016
Install-WindowsFeature FS-iSCSITarget-Server
New-Volume -StoragePoolFriendlyName S2D* -FriendlyName “iscsi-storage-host” -ResiliencySettingName Mirror -Size 100GB -FileSystem NTFS
Add-ClusteriSCSITargetServerRole -Name iscsi -Storage “Cluster Disk 2”

#Configure S2D Fault Domains
New-ClusterFaultDomain -FaultDomainType Chassis -Name “Enclosure1” -Location “Rack Unit 20”
New-ClusterFaultDomain -FaultDomainType Rack -Name “Rack1” -Location “NYC01-BLD1”
New-ClusterFaultDomain -FaultDomainType Site -Name “NYC” -Location “CONTOSO HQ NYC”

Set-ClusterFaultDomain -Name “fs01.contoso.int” -Parent “Enclosure1”
Set-ClusterFaultDomain -Name “Enclsoure1” -Parent “Rack1”
Set-ClusterFaultDomain -Name “Rack1” -Parent “NYC”

#Enable Encyrption on CSV
Install-WindowsFeature Bitlocker
Get-ClusterSharedVolume | Suspend-ClusterResource
$secureString = ConvertTo-SecureString “<Plain Text Password>” -AsPlainText Force
Enable-BitLocker C:\ClusterStorage\Volume1 -PasswordProtector -Password $secureString
Add-BitLockerKeyProtector C:\ClusterStorage\Volume1 -ADAccountOrGroupProtector -ADAccountOrGroup CLUSTER$
Get-ClusterSharedVolume | Resume-ClusterResource
