﻿#Skill 5.1 Secure the compute environment

#Deploy HGS
Install-WindowsFeature -Name HostGuardianServiceRole -IncludeManagementTools -Restart
$password = ConvertTo-SecureString -AsPlainText “<password>” -Force
Install-HgsServer -HgsDomainName “secure.contoso.int” -SafeModeAdministratorPassword $password -Restart
$certpass1 = ConvertTo-SecureString -AsPlainText “<password>” -Force
$certpass2 = ConvertTo-SecureString -AsPlainText “<password>” -Force
Initialize-HgsServer -HgsServiceName “hgs” -SigningCertificatePath “.\signingCert.pfx” -SigningCertificatePassword $certpass1 -EncryptionCertificatePath “.\encryptCert.pfx” -EncryptionCertificatePassword $certpass2 -TrustTpm
Get-HgsTrace -RunDiagnostics

#Create shiedling data file
Install-WindowsFeature RSAT-Shielded-VM-Tools
$password = ConvertTo-SecureString "<password>" -AsPlainText -Force
New-ShieldingDataAnswerFile -AdminPassword $password

$disk = Get-SCVirtualHardDisk -Name "TMPL_16_G2_CORE_SHIELDED.vhdx"
$vsc = Get-SCVolumeSignatureCatalog -VirtualHardDisk $disk
$vsc.WriteToFile(".\TMPL_16_G2_CORE_SHIELDED.vhdx")

Invoke-WebRequest "http://hgs.secure.contoso.int/KeyProtection/service/metadata/2014-07/metadata.xml" -OutFile "C:\admin\shielded\ContosoHGS.xml"

#Implement Guarded Hosts
(Get-PlatformIdentifier -Name “HV01”).InnerXml | Out-File C:\HV01.xml -Encoding UTF8

Get-HgsAttestationBaselinePolicy -Path “C:\HW1Config.tcglog”

Add-HgsAttestationTpmHost -Path “C:\HV01.xml” -Name “HV01.contoso.int” -Force

Initialize-VMShieldingHelperVHD -Path “C:\Virtual Machines\ShieldingHelper.VHDX”

#Create a CI Policy in audit mode
New-CIPolicy -Level Publisher -Fallback Hash -FilePath “C:\HW1CodeIntegrity.xml” -UserPEs
ConvertFrom-CIPolicy -XmlFilePath “C:\HW1CodeIntegrity.xml” -BinaryFilePath “C:\HW1CodeIntegrity.p7b”

#Apply the CI Policy in audit mode
Copy-Item -Path “C:\HW1CodeIntegrity.p7b” -Destination “C:\Windows\System32\CodeIntegrity\SIPolicy.p7b”
Restart-Computer

#Set the policy to enforced mode and re-apply
Set-RuleOption -FilePath “C:\HW1CodeIntegrity.xml” -Option 3 -Delete
ConvertFrom-CIPolicy -XmlFilePath “C:\HW1CodeIntegrity.xml” -BinaryFilePath “C:\HW1CodeIntegrity.p7b”
Copy-Item -Path “C:\HW1CodeIntegrity.p7b” -Destination “C:\Windows\System32\CodeIntegrity\SIPolicy.p7b”
Restart-Computer
